' AddHeadingID.vbs: add the ID to each heading in markdown
'      2019/03/13
'      2019/11/26 (WildCard̃oOC)
'    Copyright (C) T. Yoshiizumi, 2019 All rights reserved.
Option Explicit
Main WScript.Arguments
WScript.Quit

' -- v
Sub Main(argsObj)
    Dim fso, shellObj, scriptDir, fileList, inputFile
    Dim awkFile, extName, targetFile, aidFile
    Dim cmdLine, resultArray, RC
        ' eϐ̏ݒ
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    scriptDir = fso.GetParentFolderName(Wscript.ScriptFullName)
    Set fileList = CreateObject("System.Collections.ArrayList")  ' ϒz
        ' Ώۃt@C̔c
    If argsObj.Count < 2 Then
        If argsObj.Count < 1 Then
            inputFile = InputBox("t@CH", "t@C̓")
        Else
            inputFile = argsObj(0)
        End If
        If inputFile = "" Then
            Exit Sub
        End If
        If inputFile = "/" Or LCase(inputFile) = "sendto" Then
            setSendTo
            Exit Sub
        End If
        GetWildCard inputFile, fileList
    Else  ' argsObj.Count >= 2
        For Each inputFile In argsObj
            GetWildCard inputFile, fileList
        Next
    End If
        ' eo̓t@C̐ݒ
    If fileList.Count = 0 Then
        Exit Sub
    Else
        shellObj.CurrentDirectory = fso.GetParentFolderName( _
            FullPath(fileList(0)))
    End If
    SetProcessEnv
        ' awk script ̏Ǝs
    extName = ".ahid"
    awkFile = scriptDir & "\AddHeadingID.awk"
    awkFile = Replace(awkFile, "\\", "\")
    If fso.FileExists(awkFile) = False Then
        WriteAwkScript awkFile, extName
    End If
    For Each targetFile In fileList
        aidFile = ConveredFileName(targetFile)
        If (fso.FileExists(aidFile) = True) Then fso.DeleteFile(aidFile)
        cmdLine = "gawk -f " & awkFile & " " & targetFile & " " & aidFile
        resultArray = ExecCmd(cmdLine)
        RC = resultArray(0)
        If RC <> 0 Then
            If (fso.FileExists(aidFile) = True) Then fso.DeleteFile(aidFile)
        End If
        If resultArray(1) <> "" Then
            MessageWrite "X_OUT.TXT", resultArray(1)
        End If
        If resultArray(2) <> "" Then
            MessageWrite "X_ERROR.TXT", resultArray(2)
        End If
    Next
    'fso.DeleteFile(awkFile)
End Sub

' ---- output the awk script
Sub WriteAwkScript(awkFile, extName)
    Dim lines, line, fso, scrOut
    lines = Array("BEGIN {outf=ARGV[2]; ARGC=2; FS=""\n""}", _
        "/^~~~+|^```+/ {", _
        "  if (in_block == 0) {", _
        "    w = $0", _
        "    sub(/[^~`]+$/, """", w)", _
        "    fence = w", _
        "    in_block = 1", _
        "  } else {", _
        "    if ($0 == fence) {", _
        "      in_block = 0", _
        "    }", _
        "  }", _
        "  lines[++ln] = $0", _
        "  next", _
        "}", _
        "in_block == 1 {", _
        "  lines[++ln] = $0", _
        "  next", _
        "}", _
        "/^#+ +.+ +\{[^}]+\} *$/ {", _
        "  match($0, /^(#+ +.+) +\{([^}]+)\} *$/, v)", _
        "  if (v[2] ~ /#/) {", _
        "    lines[++ln] = $0", _
        "    next", _
        "  }", _
        "  if (v[2] == ""-"") {v[2] = "".unnumbered""}", _
        "  ++count", _
        "  lines[++ln] = sprintf(""%s {#session-ex%d %s}"", v[1], count, v[2])", _
        "  next", _
        "}", _
        "/^#+ +/ {", _
        "  ++count", _
        "  lines[++ln] = sprintf(""%s {#session-ex%d}"", $0, count)", _
        "  next", _
        "}", _
        "{ lines[++ln] = $0 }", _
        "END {", _
        "  if (count > 0) {", _
        "    for (i=1; i<=ln; i++) {print lines[i] > outf}", _
        "  }", _
        "}")
        ' output awk script
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set scrOut = fso.OpenTextFile(awkFile, 2, True)
    For Each line In lines
        scrOut.WriteLine line
    Next
    scrOut.Close
End Sub

' -- t@C̃tpX𓾂
Function FullPath(ByVal Fname)  ' t@C̐΃pX̎擾
    Dim fso
    Set fso = CreateObject("Scripting.FileSystemObject")
   FullPath = fso.GetAbsolutePathName(Fname)
    Set fso = Nothing
End Function

' -- gqpX擾
Function CutExtName(ByVal Fname)
    Dim fso, ExtName
    Set fso = CreateObject("Scripting.FileSystemObject")
    ExtName = fso.GetExtensionName(Fname)
    If ExtName <> "" Then
        Fname = Mid(Fname, 1, InStr(Fname, "." & ExtName) - 1)
    End If
    CutExtName = Fname
    Set fso = Nothing
End Function

' -- ChJ[h̓Iȃt@C̃Xgɂ
Sub GetWildCard(ByVal wildName, fileList)
    Dim fso, fname, dname, cname, ptn, f, ch
    Dim regEx, Match, Matches, RetStr
        ' t@CAtH_Ȃǂ𓾂
    Set fso = CreateObject("Scripting.FileSystemObject")
    wildName = fso.GetAbsolutePathName(wildName)
    If InStr(wildName, "*") = 0 And InStr(wildName, "?") = 0 Then
        fileList.Add wildName
        Exit Sub
    End If
    fname = fso.GetFileName(wildName)
    dname = fso.GetParentFolderName(wildName)
    If fso.FolderExists(dname) = False Then
        Exit Sub
    End If
    cname = fso.GetFolder(".")
    If Right(fname, 3) = "*.*" Then
        ptn = Left(fname, Len(fname)-2)
    ElseIf Right(fname, 2) = ".*" Then
        ptn = Left(fname, Len(fname)-2) & "*"
    Else
        ptn = fname
    End If
    ptn = Replace(ptn, "\", Chr(7) & Chr(7))
    For Each ch In Split(".,(,),[,],{,},^,$,+,|", ",")
        ptn = Replace(ptn, ch, Chr(7) & ch)
    Next
    ptn = Replace(ptn, "*", ".*")
    ptn = Replace(ptn, "?", ".?")
    ptn = Replace(ptn, Chr(7), "\")
    ptn = "^" & ptn & "$"
    Set regEx = New RegExp
    regEx.Pattern = ptn
    regEx.Global = True
    regEx.IgnoreCase = True
        ' tH_̃t@CƃChJ[hEp^[Ƃ̏ƍo
    For Each f In fso.GetFolder(dname).Files
        Set Matches = regEx.Execute(f.Name)
        If Matches.Count > 0 Then
            Set Match = Matches(0)
            If dname <> cname Then
                fileList.Add dname & "\" & Match.Value
            Else
                fileList.Add Match.Value
            End If
        End If
    Next
End Sub

' -- R}hC̎sBG[R[h, Wo, WG[o͂ԂB
Function ExecCmd(cmdLine)
    Dim shellObj, execObj, errorFlag
    Dim RC, StdOut, StdErr, outStr, errStr
    Set shellObj = WScript.CreateObject("WScript.Shell")
    errorFlag = False
    On Error Resume Next
    Set execObj = shellObj.Exec(cmdLine)
    If Err.Number <> 0 Then
        errorFlag = True
    End If
    Err.Clear
    On Error Goto 0
    If errorFlag = False Then
        Do While execObj.Status = 0
            WScript.Sleep 100
        Loop
        RC = execObj.ExitCode
        Set StdOut = execObj.StdOut
        Set StdErr = execObj.StdErr
        outStr = ""
        Do While Not StdOut.AtEndOfStream
            outStr = outStr & StdOut.ReadLine() & vbNewLine
        Loop
        errStr = ""
        Do While Not StdErr.AtEndOfStream
            errStr = errStr & StdErr.ReadLine() & vbNewLine
        Loop
        ExecCmd = Array(RC, outStr, errStr)
    Else  ' G[̏ꍇ
        ExecCmd = Array(255, "", "")
    End If
End Function

' -- t@Cւ̏o
Sub MessageWrite(ByVal logFile, ByVal msgStr)
    Dim fso, msgOut
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set msgOut = fso.OpenTextFile(logFile, 8, True)  ' ǉ
    msgOut.WriteLine msgStr
    msgOut.Close
End Sub

' ---- vZX̊ϐ Path ύX
Sub SetProcessEnv()
    Dim shellObj, fso, env, addPath, orgPath
    Dim si, str, alen
    Set shellObj = CreateObject("WScript.Shell")
    Set fso = CreateObject("Scripting.FileSystemObject")
    addPath = fso.getParentFolderName(WScript.ScriptFullName)
    Set env = shellObj.Environment("Process")
    orgPath = CStr(env.Item("PATH"))
    alen = Len(addPath)
    si = InStr(orgPath, addPath)
    If si > 0 Then
        str = Mid(orgPath, si, alen+1)
        If alen = Len(str) Then Exit Sub
        If Right(str, 1) = ";" Then Exit Sub
    End If
    env.Item("PATH") = addPath & ";" & orgPath
End Sub

' -- IDt̕ԊҌ̃t@C
Function ConveredFileName(ByVal Fname)
    Dim fso, extName, newName
    Set fso = CreateObject("Scripting.FileSystemObject")
    extName = fso.GetExtensionName(Fname)
    newName = Fname
    If extName <> "" Then
        extName = "." & extName
        newName = Mid(Fname, 1, InStr(Fname, extName) - 1) & "+ID" & extName
    Else
        newName = Fname & "+ID"
    End If
    ConveredFileName = newName
    Set fso = Nothing
End Function

' -- 郁j[ւ̓o^܂͏
Sub setSendTo()
    Dim fso, shellObj, scriptDir, sendtoDir
    Dim targetFile, targetName, lnkFile, shortcut
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    targetFile = Wscript.ScriptFullName
    targetName = fso.GetBaseName(targetFile)
    sendtoDir = shellObj.SpecialFolders("SendTo")
    lnkFile = sendtoDir & "\" & targetName & ".lnk"
    If (fso.FileExists(lnkFile) = True) Then
        fso.DeleteFile(lnkFile)
        MsgBox "郁j[ " & targetName & "܂.", _
            0, ""
        Exit Sub
    End If
    Set shortcut = shellObj.CreateShortCut(lnkFile)
    shortcut.TargetPath = targetFile
    shortcut.save
    MsgBox "郁j[ " & targetName & "o^܂.", 0, "o^"
End Sub
