' ExportPDF.vbs: Excel, Word, PowerPoint files  PDF
'    Copyright (C) T. Yoshiizumi, 2019 All rights reserved.
'      2019/11/26
Option Explicit
Const wdExportFormatPDF = 17
Const wdExportOptimizeForPrint = 0
Const wdExportAllDocument = 0
Const ppFixedFormatTypePDF = 2
Const xlTypePDF = 0
Const xlQualityStandard = 0

Main WScript.Arguments
WScript.Quit

' -- v
Sub Main(argsObj)
    Dim fso, shellObj, wdApp, pptApp, exlApp
    Dim inputFile, fileList, focusFile, scriptDir
    Dim errorCount, logFile, ext3, exportCount, exportFlag
    Dim soundVolume, normalSound, errorSound

    soundVolume = 100
    normalSound = "C:\Windows\Media\tada.wav"  ' ÎƂ̉
    errorSound = "C:\Windows\Media\ringout.wav"  ' G[ÎƂ̉
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    scriptDir = fso.GetParentFolderName(Wscript.ScriptFullName)
    Set fileList = CreateObject("System.Collections.ArrayList")  ' ϒz
    Set wdApp = Nothing
    Set pptApp = Nothing
    Set exlApp = Nothing

        ' Ώۃt@C̔c
    If argsObj.Count < 2 Then
        If argsObj.Count < 1 Then
            inputFile = InputBox("t@CH", "t@C̓")
        Else
            inputFile = argsObj(0)
        End If
        If inputFile = "" Then
            Exit Sub
        End If
        If inputFile = "/" Or LCase(inputFile) = "sendto" Then
            setSendTo
            Exit Sub
        End If
        GetWildCard inputFile, fileList
    Else  ' argsObj.Count >= 2
        For Each inputFile In argsObj
            GetWildCard inputFile, fileList
        Next
    End If
        ' eo̓t@C̐ݒ
    If fileList.Count = 0 Then
        shellObj.CurrentDirectory = scriptDir
    Else
        shellObj.CurrentDirectory = fso.GetParentFolderName( _
            fso.GetAbsolutePathName(fileList(0)))
    End If
    logFile = "log.txt"  ' Oot@C
    If (fso.FileExists(logFile) = True) Then fso.DeleteFile(logFile)
    MessageWrite logFile, "ExportPDF :"
    errorCount = 0
    If fileList.Count = 0 Then
        MessageWrite logFile, "'" & inputFile & _
            "' ܂." & vbNewLine
        errorCount = errorCount + 1
    End If
    exportCount = 0
    For Each focusFile In fileList
        ext3 = LCase(Left(fso.GetExtensionName(focusFile), 3))
        exportFlag = True
        If ext3 = "doc" Then
            ExportFromWord wdApp, focusFile, logFile
        ElseIf ext3 = "ppt" Then
            ExportFromPpt pptApp, focusFile, logFile
        ElseIf ext3 = "xls" Then
            ExportFromExcel exlApp, focusFile, logFile
        Else
            exportFlag = False
        End If
        If exportFlag = True Then
            exportCount = exportCount + 1
            MessageWrite logFile, "* t@C: " & _
                fso.GetFileName(focusFile)
        Else
            MessageWrite logFile, "* ΏۊO: " & _
                fso.GetFileName(focusFile)
        End If
    Next
    If exportCount > 0 Then
        MessageWrite logFile, exportCount & "PDFo܂."
    Else
        MessageWrite logFile, "Ώۃt@C݂܂ł."
        errorCount = errorCount + 1
    End If
    If TypeName(wdApp) <> "Nothing" Then
        wdApp.Quit
    End If
    If TypeName(pptApp) <> "Nothing" Then
        pptApp.Quit
    End If
    If TypeName(exlApp) <> "Nothing" Then
        exlApp.Quit
    End If
    If (errorCount > 0) Then
        SoundPlay errorSound, soundVolume
    Else
        SoundPlay normalSound, soundVolume
    End If
End Sub

' -- t@Cւ̏o
Sub MessageWrite(ByVal logFile, ByVal msgStr)
    Dim fso, msgOut
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set msgOut = fso.OpenTextFile(logFile, 8, True)  ' ǉ
    msgOut.WriteLine msgStr
    msgOut.Close
End Sub

' -- ChJ[h̓Iȃt@C̃Xgɂ
Sub GetWildCard(ByVal wildName, fileList)
    Dim fso, fname, dname, cname, ptn, f, ch
    Dim regEx, Match, Matches, RetStr
        ' t@CAtH_Ȃǂ𓾂
    Set fso = CreateObject("Scripting.FileSystemObject")
    wildName = fso.GetAbsolutePathName(wildName)
    If InStr(wildName, "*") = 0 And InStr(wildName, "?") = 0 Then
        fileList.Add wildName
        Exit Sub
    End If
    fname = fso.GetFileName(wildName)
    dname = fso.GetParentFolderName(wildName)
    If fso.FolderExists(dname) = False Then
        Exit Sub
    End If
    cname = fso.GetFolder(".")
    If Right(fname, 3) = "*.*" Then
        ptn = Left(fname, Len(fname)-2)
    ElseIf Right(fname, 2) = ".*" Then
        ptn = Left(fname, Len(fname)-2) & "*"
    Else
        ptn = fname
    End If
    ptn = Replace(ptn, "\", Chr(7) & Chr(7))
    For Each ch In Split(".,(,),[,],{,},^,$,+,|", ",")
        ptn = Replace(ptn, ch, Chr(7) & ch)
    Next
    ptn = Replace(ptn, "*", ".*")
    ptn = Replace(ptn, "?", ".?")
    ptn = Replace(ptn, Chr(7), "\")
    ptn = "^" & ptn & "$"
    Set regEx = New RegExp
    regEx.Pattern = ptn
    regEx.Global = True
    regEx.IgnoreCase = True
        ' tH_̃t@CƃChJ[hEp^[Ƃ̏ƍo
    For Each f In fso.GetFolder(dname).Files
        Set Matches = regEx.Execute(f.Name)
        If Matches.Count > 0 Then
            Set Match = Matches(0)
            If dname <> cname Then
                fileList.Add dname & "\" & Match.Value
            Else
                fileList.Add Match.Value
            End If
        End If
    Next
End Sub

' -- t@C̍Đ
Sub SoundPlay(wavFile, soundVolume)
    Dim fso, wmp
Set fso = CreateObject("Scripting.FileSystemObject")
    If (fso.FileExists(wavFile) = False) Then
        Exit Sub
    End If
    Set wmp = CreateObject("WMPlayer.OCX")
    wmp.settings.volume = soundVolume ' ʐݒ
    wmp.URL = wavFile
    wmp.Controls.play()  ' Đ
    Do  ' Đҋ@
        WScript.sleep(5)
    Loop Until wmp.playState = 1  ' ~҂
End Sub

' -- 郁j[ւ̓o^܂͏
Sub setSendTo()
    Dim fso, shellObj, scriptDir, sendtoDir
    Dim targetFile, targetName, lnkFile, shortcut
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    targetFile = Wscript.ScriptFullName
    targetName = fso.GetBaseName(targetFile)
    sendtoDir = shellObj.SpecialFolders("SendTo")
    lnkFile = sendtoDir & "\" & targetName & ".lnk"
    If (fso.FileExists(lnkFile) = True) Then
        fso.DeleteFile(lnkFile)
        MsgBox "郁j[ " & targetName & "܂.", _
            0, ""
        Exit Sub
    End If
    Set shortcut = shellObj.CreateShortCut(lnkFile)
    shortcut.TargetPath = targetFile
    shortcut.save
    MsgBox "郁j[ " & targetName & "o^܂.", 0, "o^"
End Sub

' ----
Sub ExportFromWord(wdApp, ByVal focusFile, ByVal logFile)
    Dim fso, docPath, docObj, outFolder, pdfPath, wname

        ' PDFt@CotH_̍쐬
    Set fso = CreateObject("Scripting.FileSystemObject")
        ' Word̃t@CI[v
    docPath = fso.GetAbsolutePathName(focusFile)
    wname = fso.GetFileName(docPath)
    outFolder = Left(docPath, Len(docPath) - Len(wname)) & "pdf"
    outFolder = SetOutFolder(outFolder, "pdf")
    pdfPath = outFolder & "\" & wname & ".pdf"
    If (fso.FileExists(pdfPath) = True) Then fso.DeleteFile(pdfPath)
    If TypeName(wdApp) = "Nothing" Then
        Set wdApp = CreateObject("Word.Application")  ' Word̋N
        wdApp.Visible = True  ' Word̏ߒԂ
    End If
    Set docObj = wdApp.Documents.Open(docPath)
    docObj.ExportAsFixedFormat pdfPath, wdExportFormatPDF, , _
        wdExportOptimizeForPrint, wdExportAllDocument
    docObj.Close
End Sub

' ----
Sub ExportFromPpt(pptApp, ByVal focusFile, ByVal logFile)
    Dim fso, pptPath, presenObj, outFolder, pdfPath, wname, prng

        ' PDFt@CotH_̍쐬
    Set fso = CreateObject("Scripting.FileSystemObject")
        ' Word̃t@CI[v
    pptPath = fso.GetAbsolutePathName(focusFile)
    wname = fso.GetFileName(pptPath)
    outFolder = Left(pptPath, Len(pptPath) - Len(wname)) & "pdf"
    outFolder = SetOutFolder(outFolder, "pdf")
    pdfPath = outFolder & "\" & wname & ".pdf"
    If (fso.FileExists(pdfPath) = True) Then fso.DeleteFile(pdfPath)
    If TypeName(pptApp) = "Nothing" Then
        Set pptApp = CreateObject("PowerPoint.Application")  ' Ppt̋N
        pptApp.Visible = True  ' Ppt̏ߒԂ
    End If
    Set presenObj = pptApp.Presentations.Open(pptPath)
    presenObj.PrintOptions.Ranges.ClearAll  ' ͈͂NA
    Set prng = presenObj.PrintOptions.Ranges.Add(1, presenObj.Slides.Count)
    presenObj.ExportAsFixedFormat pdfPath, _
        ppFixedFormatTypePDF, , , , , , prng
    presenObj.Saved = True
    presenObj.Close
End Sub

' ----
Sub ExportFromExcel(exlApp, ByVal focusFile, ByVal logFile)
    Dim fso, xlsPath, wbObj, outFolder, pdfPath, wname

        ' PDFt@CotH_̍쐬
    Set fso = CreateObject("Scripting.FileSystemObject")
        ' Excel̃t@CI[v
    xlsPath = fso.GetAbsolutePathName(focusFile)
    wname = fso.GetFileName(xlsPath)
    outFolder = Left(xlsPath, Len(xlsPath) - Len(wname)) & "pdf"
    outFolder = SetOutFolder(outFolder, "pdf")
    pdfPath = outFolder & "\" & wname & ".pdf"
    If (fso.FileExists(pdfPath) = True) Then fso.DeleteFile(pdfPath)
    If TypeName(exlApp) = "Nothing" Then
        Set exlApp = CreateObject("Excel.Application")  ' Excel̋N
        exlApp.Visible = True  ' Excel̏ߒԂ
    End If
    Set wbObj = exlApp.Workbooks.Open(xlsPath)
    wbObj.ExportAsFixedFormat xlTypePDF, pdfPath, xlQualityStandard
    wbObj.Close
End Sub

' ----
Function SetOutFolder(ByVal outFolder, ByVal folderName)
    Dim fso
    Set fso = CreateObject("Scripting.FileSystemObject")
    If (fso.FolderExists(outFolder) = False And _
        fso.FileExists(outFolder) = False) Then
        fso.CreateFolder(outFolder)
    End If
    If fso.FolderExists(outFolder) = False Then
        outFolder = Left(outFolder, Len(outFolder) - Len(folderName)+1)
    End If
    SetOutFolder = outFolder
End Function
