' copyTable.vbs: tables in Word|PowerPoint  Excel
'      2019/03/13
'      2019/11/26 (WildCard̃oOC, pptɑΉ)
'    Copyright (C) T. Yoshiizumi, 2019 All rights reserved.
Option Explicit
Const xlOpenXMLWorkbook = 51
Const xlFormulas = -4123
Const xlByRows = 1
Const xlPrevious = 2

Main WScript.Arguments
WScript.Quit

' -- v
Sub Main(argsObj)
    Dim fso, shellObj, wdApp, pptApp, exlApp
    Dim inputFile, fileList, focusFile, scriptDir
    Dim errorCount, logFile, ext3, tblCount, copyCount, copyFlag
    Dim soundVolume, normalSound, errorSound

    soundVolume = 100
    normalSound = "C:\Windows\Media\tada.wav"  ' ÎƂ̉
    errorSound = "C:\Windows\Media\ringout.wav"  ' G[ÎƂ̉
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    scriptDir = fso.GetParentFolderName(Wscript.ScriptFullName)
    Set fileList = CreateObject("System.Collections.ArrayList")  ' ϒz
    Set wdApp = Nothing
    Set pptApp = Nothing
    Set exlApp = Nothing

        ' Ώۃt@C̔c
    If argsObj.Count < 2 Then
        If argsObj.Count < 1 Then
            inputFile = InputBox("t@CH", "t@C̓")
        Else
            inputFile = argsObj(0)
        End If
        If inputFile = "" Then
            Exit Sub
        End If
        If inputFile = "/" Or LCase(inputFile) = "sendto" Then
            setSendTo
            Exit Sub
        End If
        GetWildCard inputFile, fileList
    Else  ' argsObj.Count >= 2
        For Each inputFile In argsObj
            GetWildCard inputFile, fileList
        Next
    End If
        ' eo̓t@C̐ݒ
    If fileList.Count = 0 Then
        shellObj.CurrentDirectory = scriptDir
    Else
        shellObj.CurrentDirectory = fso.GetParentFolderName( _
            fso.GetAbsolutePathName(fileList(0)))
    End If
    logFile = "log.txt"  ' Oot@C
    If (fso.FileExists(logFile) = True) Then fso.DeleteFile(logFile)
    MessageWrite logFile, "copyTable :"
    errorCount = 0
    If fileList.Count = 0 Then
        MessageWrite logFile, "'" & inputFile & _
            "' ܂." & vbNewLine
        errorCount = errorCount + 1
    End If
    copyCount = 0
    For Each focusFile In fileList
        copyFlag = 1
        ext3 = LCase(Left(fso.GetExtensionName(focusFile), 3))
        If ext3 = "doc" Then
            tblCount = CopyWordTable(wdApp, exlApp, focusFile, logFile)
            If tblCount = 0 Then copyFlag = 0
        ElseIf ext3 = "ppt" Then
            tblCount = CopyPptTable(pptApp, exlApp, focusFile, logFile)
            If tblCount = 0 Then copyFlag = 0
        Else
            copyFlag = -1
        End If
        If copyFlag = 1 Then
            copyCount = copyCount + 1
            MessageWrite logFile, "* " & fso.GetFileName(focusFile) & _
                vbCrLf & vbTab & tblCount & "tableo."
        ElseIf copyFlag = 0 Then
            MessageWrite logFile, "* " & fso.GetFileName(focusFile) & _
                vbCrLf & vbTab & "table܂."
        Else
            MessageWrite logFile, "* ΏۊO: " & _
                fso.GetFileName(focusFile)
        End If
    Next
    If copyCount > 0 Then
        MessageWrite logFile, "* o͌: " & copyCount & _
            "Excelt@Co͂܂."
    Else
        errorCount = errorCount + 1
        MessageWrite logFile, "tablẽRs[͍s܂ł."
    End If
    If TypeName(wdApp) <> "Nothing" Then
        wdApp.Quit
    End If
    If TypeName(pptApp) <> "Nothing" Then
        pptApp.Quit
    End If
    If TypeName(exlApp) <> "Nothing" Then
        exlApp.Quit
    End If
    If (errorCount > 0) Then
        SoundPlay errorSound, soundVolume
    Else
        SoundPlay normalSound, soundVolume
    End If
End Sub

' ----
Function CopyWordTable(wdApp, exlApp, ByVal focusFile, ByVal logFile)
    Dim fso, docPath, docObj, tblObj, rng, i, outFolder
    Dim startPos, endPos, titleFlag
    Dim bookPath, wb, ws, wsStart, wsEnd, tblCount, wname

        ' Excelt@CotH_̍쐬
    Set fso = CreateObject("Scripting.FileSystemObject")
        ' Word̃t@CI[v
    docPath = fso.GetAbsolutePathName(focusFile)
    If TypeName(wdApp) = "Nothing" Then
        Set wdApp = CreateObject("Word.Application")  ' Word̋N
        wdApp.Visible = True  ' Word̏ߒԂ
    End If
    Set docObj = wdApp.Documents.Open(docPath)
    If (docObj.Tables.Count < 1) Then
        docObj.Close
        CopyWordTable = 0
        Exit Function
    End If
        ' Excel̋Oƃ[NubÑI[v
    If TypeName(exlApp) = "Nothing" Then
        Set exlApp = CreateObject("Excel.Application")  ' Excel̋N
        exlApp.Visible = True  ' Excel̏ߒԂ
    End If
    Set wb = exlApp.Workbooks.Add
    Set ws = wb.Worksheets(1)
    ws.Activate
    tblCount = 0
    wsStart = 1
    wsEnd = 1
        ' WordTable`FbN
    With docObj
            ' \Rangecopy
        For Each tblObj In .Tables
            startPos = tblObj.Range.Start
            endPos = tblObj.Range.End
            titleFlag = False
            Set rng = tblObj.Cell(1, 1).Range
            rng.Start = 0
            i = rng.Paragraphs.Count
            If i > 1 Then
                Set rng = .Paragraphs(i-1).Range  ' \̐HO̒i
                If rng.Style.NameLocal = "Table Caption" Then
                    startPos = rng.Start
                    titleFlag = True
                End If
            End If
            Set rng = .Range(startPos, endPos)
            rng.Copy
            ws.Cells.Item(wsStart,1).Select
            ws.Paste
            exlApp.CutCopyMode = False
            If titleFlag = True Then
                ws.Cells.Item(wsStart+1,1).CurrentRegion.Columns.AutoFit
            Else
                ws.Cells.Item(wsStart,1).CurrentRegion.Columns.AutoFit
            End If
            tblCount = tblCount + 1
            With ws.UsedRange
                wsEnd = .Find("*", , xlFormulas, , xlByRows, xlPrevious).Row
            End With
            wsStart = wsEnd + 3
        Next
    End With
    docObj.Close
    wname = fso.GetFileName(docPath)
    outFolder = Left(docPath, Len(docPath) - Len(wname)) & "xlsx"
    outFolder = SetOutFolder(outFolder, "xlsx")
    bookPath = outFolder & "\" & wname & ".xlsx"
    If (fso.FileExists(bookPath) = True) Then fso.DeleteFile(bookPath)
    wb.Worksheets(1).Activate
    wb.Worksheets(1).Range("A1").Select
    wb.SaveAs bookPath, xlOpenXMLWorkbook
    wb.Close
    CopyWordTable = tblCount
End Function

' ----
Function CopyPptTable(pptApp, exlApp, ByVal focusFile, ByVal logFile)
    Dim fso, pptPath, presenObj, tblObj, rng, i, outFolder
    Dim sld, shp, textStr, tblFlag, ary
    Dim bookPath, wb, ws, wsStart, wsEnd, tblCount, commentPos, wname

        ' Excelt@CotH_̍쐬
    Set fso = CreateObject("Scripting.FileSystemObject")
        ' ppt̃t@CI[v
    pptPath = fso.GetAbsolutePathName(focusFile)
    If TypeName(pptApp) = "Nothing" Then
        Set pptApp = CreateObject("PowerPoint.Application")  ' ppt̋N
        pptApp.Visible = True  ' ppt̏ߒԂ
    End If
    Set presenObj = pptApp.Presentations.Open(pptPath)
        ' Excel̋Oƃ[NubÑI[v
    If TypeName(exlApp) = "Nothing" Then
        Set exlApp = CreateObject("Excel.Application")  ' Excel̋N
        exlApp.Visible = True  ' Excel̏ߒԂ
    End If
    Set wb = exlApp.Workbooks.Add
    Set ws = wb.Worksheets(1)
    ws.Activate
    tblCount = 0
    wsStart = 1
    wsEnd = 1
    For Each sld In presenObj.Slides
        tblFlag = False
        textStr = ""
        For Each shp In sld.Shapes
            If (shp.HasTable <> 0) Then tblFlag = True
            If (shp.HasTextFrame <> 0) Then
                If (shp.TextFrame.TextRange.Text <> "") Then
                    If (textStr <> "") Then textStr = textStr & vbTab
                    textStr = textStr & shp.TextFrame.TextRange.Text
                End If
            End If
        Next
        If (tblFlag = True) Then
            If (textStr <> "") Then
                commentPos = wsStart
                wsStart = wsStart + 1
            End If
            For Each shp In sld.Shapes
                If (shp.HasTable <> 0) Then
                    shp.Copy
                    ws.Cells.Item(wsStart,1).Select
                    ws.Paste
                    exlApp.CutCopyMode = False
                    ws.Cells.Item(wsStart,1).CurrentRegion.Columns.AutoFit
                    tblCount = tblCount + 1
                    With ws.UsedRange
                        wsEnd = .Find("*", , xlFormulas, , _
                            xlByRows, xlPrevious).Row
                    End With
                    wsStart = wsEnd + 3
                End If
            Next
            If (textStr <> "") Then
                ary = Split(textStr, vbTab)
                ws.Range(ws.Cells(commentPos, 1), _
                    ws.Cells(commentPos, UBound(ary)+1)).Value = ary
            End If
            End If
    Next
    presenObj.Saved = True
    presenObj.Close
    If (tblCount > 0) Then
        wname = fso.GetFileName(pptPath)
        outFolder = Left(pptPath, Len(pptPath) - Len(wname)) & "xlsx"
        outFolder = SetOutFolder(outFolder, "xlsx")
        bookPath = outFolder & "\" & wname & ".xlsx"
        If (fso.FileExists(bookPath) = True) Then fso.DeleteFile(bookPath)
        wb.Worksheets(1).Activate
        wb.Worksheets(1).Range("A1").Select
        wb.SaveAs bookPath, xlOpenXMLWorkbook
    End If
    wb.Close
    CopyPptTable = tblCount
End Function

' -- t@Cւ̏o
Sub MessageWrite(ByVal logFile, ByVal msgStr)
    Dim fso, msgOut
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set msgOut = fso.OpenTextFile(logFile, 8, True)  ' ǉ
    msgOut.WriteLine msgStr
    msgOut.Close
End Sub

' -- ChJ[h̓Iȃt@C̃Xgɂ
Sub GetWildCard(ByVal wildName, fileList)
    Dim fso, fname, dname, cname, ptn, f, ch
    Dim regEx, Match, Matches, RetStr
        ' t@CAtH_Ȃǂ𓾂
    Set fso = CreateObject("Scripting.FileSystemObject")
    wildName = fso.GetAbsolutePathName(wildName)
    If InStr(wildName, "*") = 0 And InStr(wildName, "?") = 0 Then
        fileList.Add wildName
        Exit Sub
    End If
    fname = fso.GetFileName(wildName)
    dname = fso.GetParentFolderName(wildName)
    If fso.FolderExists(dname) = False Then
        Exit Sub
    End If
    cname = fso.GetFolder(".")
    If Right(fname, 3) = "*.*" Then
        ptn = Left(fname, Len(fname)-2)
    ElseIf Right(fname, 2) = ".*" Then
        ptn = Left(fname, Len(fname)-2) & "*"
    Else
        ptn = fname
    End If
    ptn = Replace(ptn, "\", Chr(7) & Chr(7))
    For Each ch In Split(".,(,),[,],{,},^,$,+,|", ",")
        ptn = Replace(ptn, ch, Chr(7) & ch)
    Next
    ptn = Replace(ptn, "*", ".*")
    ptn = Replace(ptn, "?", ".?")
    ptn = Replace(ptn, Chr(7), "\")
    ptn = "^" & ptn & "$"
    Set regEx = New RegExp
    regEx.Pattern = ptn
    regEx.Global = True
    regEx.IgnoreCase = True
        ' tH_̃t@CƃChJ[hEp^[Ƃ̏ƍo
    For Each f In fso.GetFolder(dname).Files
        Set Matches = regEx.Execute(f.Name)
        If Matches.Count > 0 Then
            Set Match = Matches(0)
            If dname <> cname Then
                fileList.Add dname & "\" & Match.Value
            Else
                fileList.Add Match.Value
            End If
        End If
    Next
End Sub

' -- t@C̍Đ
Sub SoundPlay(wavFile, soundVolume)
    Dim fso, wmp
Set fso = CreateObject("Scripting.FileSystemObject")
    If (fso.FileExists(wavFile) = False) Then
        Exit Sub
    End If
    Set wmp = CreateObject("WMPlayer.OCX")
    wmp.settings.volume = soundVolume ' ʐݒ
    wmp.URL = wavFile
    wmp.Controls.play()  ' Đ
    Do  ' Đҋ@
        WScript.sleep(5)
    Loop Until wmp.playState = 1  ' ~҂
End Sub

' -- 郁j[ւ̓o^܂͏
Sub setSendTo()
    Dim fso, shellObj, scriptDir, sendtoDir
    Dim targetFile, targetName, lnkFile, shortcut
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    targetFile = Wscript.ScriptFullName
    targetName = fso.GetBaseName(targetFile)
    sendtoDir = shellObj.SpecialFolders("SendTo")
    lnkFile = sendtoDir & "\" & targetName & ".lnk"
    If (fso.FileExists(lnkFile) = True) Then
        fso.DeleteFile(lnkFile)
        MsgBox "郁j[ " & targetName & "܂.", _
            0, ""
        Exit Sub
    End If
    Set shortcut = shellObj.CreateShortCut(lnkFile)
    shortcut.TargetPath = targetFile
    shortcut.save
    MsgBox "郁j[ " & targetName & "o^܂.", 0, "o^"
End Sub

' ----
Function SetOutFolder(ByVal outFolder, ByVal folderName)
    Dim fso
    Set fso = CreateObject("Scripting.FileSystemObject")
    If (fso.FolderExists(outFolder) = False And _
        fso.FileExists(outFolder) = False) Then
        fso.CreateFolder(outFolder)
    End If
    If fso.FolderExists(outFolder) = False Then
        outFolder = Left(outFolder, Len(outFolder) - Len(folderName)+1)
    End If
    SetOutFolder = outFolder
End Function
