' makeHTML.vbs: markdown file  html file by pandoc
'      2019/03/02
'      2019/11/26 (WildCard̃oOC)
'    Copyright (C) T. Yoshiizumi, 2019 All rights reserved.
Option Explicit
Main WScript.Arguments
WScript.Quit

' -- v
Sub Main(argsObj)
    Dim wdApp, inputFile, sjsFile, logFile, fileList, procCount, extStr
    Dim optKeys, opt, optDict
    Dim fso, sjsPathOrg, sjsPath, utfPath, scriptDir
    Dim ExtName, outFile, cmdLine, resultArray
    Dim shellObj, RC, pandocExe, soundVolume, normalSound, errorSound
        ' eϐ̐ݒ
    extName = ".html"  ' 쐬t@C̊gq
    soundVolume = 100
    normalSound = "C:\Windows\Media\tada.wav"  ' ÎƂ̉
    errorSound = "C:\Windows\Media\ringout.wav"  ' G[ÎƂ̉
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    scriptDir = fso.GetParentFolderName(Wscript.ScriptFullName)
    pandocExe = "pandoc.exe"
    Set fileList = CreateObject("System.Collections.ArrayList")  ' ϒz
    Set wdApp = Nothing
        ' ݒ
    optKeys = Array("pandoc")
    Set optDict = WScript.CreateObject("Scripting.Dictionary")
    InitializeOptions optKeys, optDict
        ' Ώۃt@C̔c
    If argsObj.Count < 2 Then
        If argsObj.Count < 1 Then
            inputFile = InputBox("t@CH", "t@C̓")
        Else
            inputFile = argsObj(0)
        End If
        If inputFile = "" Then
            Exit Sub
        End If
        If inputFile = "/" Or LCase(inputFile) = "sendto" Then
            setSendTo
            Exit Sub
        End If
        GetWildCard inputFile, fileList
    Else  ' argsObj.Count >= 2
        For Each inputFile In argsObj
            GetWildCard inputFile, fileList
        Next
    End If
        ' eo̓t@C̐ݒ
    If fileList.Count = 0 Then
        shellObj.CurrentDirectory = scriptDir
    Else
        shellObj.CurrentDirectory = fso.GetParentFolderName( _
            FullPath(fileList(0)))
    End If
    logFile = "log.txt"  ' Oot@C
    If (fso.FileExists(logFile) = True) Then fso.DeleteFile(logFile)
    MessageWrite logFile, "makeHTML :"
    procCount = 0
    If fileList.Count = 0 Then
        MessageWrite logFile, "'" & inputFile & _
            "' ܂." & vbNewLine
    End If
    SetProcessEnv
    For Each sjsFile In fileList
        extStr = LCase(fso.GetExtensionName(sjsFile))
        If extStr <> "" And InStr("txt md", extStr) > 0 And _
            FullPath(sjsFile) <> FullPath(logFile) Then
            MessageWrite logFile, "* t@C: " & fso.GetFileName(sjsFile)
            sjsPathOrg = FullPath(sjsFile)
            sjsPath = sjsPathOrg
            sjsPath = AddHeadingID(sjsPath, scriptDir)
            utfPath = CutExtName(sjsPathOrg) & ".$utf"
            If (fso.FileExists(utfPath) = True) Then fso.DeleteFile(utfPath)
            SjsToUtf sjsPath, utfPath  ' ShiftJIS  utf-8
            outFile = CutExtName(utfPath) & extName
            If (fso.FileExists(outFile) = True) Then fso.DeleteFile(outFile)
            GetOptions sjsPath, optKeys, optDict
            cmdLine = pandocExe & " """ & utfPath & """ -s -f markdown " & _
                "--data-dir=""" & scriptDir & "\pandoc"" " & _
                "-o """ & outFile & """ " & optDict("pandoc")
            resultArray = ExecCmd(cmdLine)
            fso.DeleteFile(utfPath)
            If sjsPath <> sjsPathOrg Then
                fso.DeleteFile(sjsPath)
                MessageWrite logFile, "* IDt܂."
            End If
            RC = resultArray(0)
            If RC <> 0 Then
                MessageWrite logFile, "* pandoc̎sɎs܂." & _
                    vbNewLine & "* CommandLine: " & cmdLine
            Else
                MessageWrite logFile, "* pandoc̎sɐ."
                procCount = procCount + 1
            End If
            If resultArray(1) <> "" Then
                MessageWrite logFile, "* StdOut: " & resultArray(1)
            End If
            If resultArray(2) <> "" Then
                MessageWrite logFile, "* StdErr: " & resultArray(2)
            End If
            MessageWrite logFile, ""
        ElseIf FullPath(sjsFile) <> FullPath(logFile) Then
            MessageWrite logFile, "* ΏۊO: " & fso.GetFileName(sjsFile)
        End If
    Next

    If TypeName(wdApp) <> "Nothing" Then
        wdApp.Quit
    End If
    If (procCount = 0) Then
        SoundPlay errorSound, soundVolume
    Else
        SoundPlay normalSound, soundVolume
    End If
End Sub

' -- t@C̃tpX𓾂
Function FullPath(ByVal Fname)  ' t@C̐΃pX̎擾
    Dim fso
    Set fso = CreateObject("Scripting.FileSystemObject")
   FullPath = fso.GetAbsolutePathName(Fname)
    Set fso = Nothing
End Function

' -- gqpX擾
Function CutExtName(ByVal Fname)
    Dim fso, ExtName
    Set fso = CreateObject("Scripting.FileSystemObject")
    ExtName = fso.GetExtensionName(Fname)
    If ExtName <> "" Then
        Fname = Mid(Fname, 1, InStr(Fname, "." & ExtName) - 1)
    End If
    CutExtName = Fname
    Set fso = Nothing
End Function

' -- Shift_JIS file  utf-8 file
Sub SjsToUtf(ByVal sjsPath, ByVal utfPath)
    Dim objSJIS, objUTF8
    Set objSJIS = CreateObject("ADODB.Stream")
    Set objUTF8 = CreateObject("ADODB.Stream")
    objSJIS.Type = 2
    objSJIS.Charset = "Shift_JIS"
    objSJIS.Open
    objSJIS.LoadFromFile sjsPath
    objUTF8.Type = 2
    objUTF8.Charset = "UTF-8"
    objUTF8.Open
    objSJIS.CopyTo objUTF8
    objUTF8.SaveTofile utfPath
    objSJIS.Close
    objUTF8.Close
End Sub

' -- t@Cւ̏o
Sub MessageWrite(ByVal logFile, ByVal msgStr)
    Dim fso, msgOut
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set msgOut = fso.OpenTextFile(logFile, 8, True)  ' ǉ
    msgOut.WriteLine msgStr
    msgOut.Close
End Sub

' -- K\̏ƍB}b`ԂB
Function regexMatch(ByVal patrn, ByVal strng)
    Dim regEx, Match, Matches, RetStr
    Set regEx = New RegExp
    regEx.Pattern = patrn
    regEx.Global = True
    Set Matches = regEx.Execute(strng)
    If Matches.Count > 0 Then
        Set Match = Matches(0)
        RetStr = Match.Value
    Else  ' }b`ȂƂ͌̕񂻂̂܂܂Ԃ
        RetStr = strng
    End If
    regexMatch = RetStr
End Function

' -- t@C̍Đ
Sub SoundPlay(wavFile, soundVolume)
    Dim fso, wmp
Set fso = CreateObject("Scripting.FileSystemObject")
    If (fso.FileExists(wavFile) = False) Then
        Exit Sub
    End If
    Set wmp = CreateObject("WMPlayer.OCX")
    wmp.settings.volume = soundVolume ' ʐݒ
    wmp.URL = wavFile
    wmp.Controls.play()  ' Đ
    Do  ' Đҋ@
        WScript.sleep(5)
    Loop Until wmp.playState = 1  ' ~҂
End Sub

' -- ChJ[h̓Iȃt@C̃Xgɂ
Sub GetWildCard(ByVal wildName, fileList)
    Dim fso, fname, dname, cname, ptn, f, ch
    Dim regEx, Match, Matches, RetStr
        ' t@CAtH_Ȃǂ𓾂
    Set fso = CreateObject("Scripting.FileSystemObject")
    wildName = fso.GetAbsolutePathName(wildName)
    If InStr(wildName, "*") = 0 And InStr(wildName, "?") = 0 Then
        fileList.Add wildName
        Exit Sub
    End If
    fname = fso.GetFileName(wildName)
    dname = fso.GetParentFolderName(wildName)
    If fso.FolderExists(dname) = False Then
        Exit Sub
    End If
    cname = fso.GetFolder(".")
    If Right(fname, 3) = "*.*" Then
        ptn = Left(fname, Len(fname)-2)
    ElseIf Right(fname, 2) = ".*" Then
        ptn = Left(fname, Len(fname)-2) & "*"
    Else
        ptn = fname
    End If
    ptn = Replace(ptn, "\", Chr(7) & Chr(7))
    For Each ch In Split(".,(,),[,],{,},^,$,+,|", ",")
        ptn = Replace(ptn, ch, Chr(7) & ch)
    Next
    ptn = Replace(ptn, "*", ".*")
    ptn = Replace(ptn, "?", ".?")
    ptn = Replace(ptn, Chr(7), "\")
    ptn = "^" & ptn & "$"
    Set regEx = New RegExp
    regEx.Pattern = ptn
    regEx.Global = True
    regEx.IgnoreCase = True
        ' tH_̃t@CƃChJ[hEp^[Ƃ̏ƍo
    For Each f In fso.GetFolder(dname).Files
        Set Matches = regEx.Execute(f.Name)
        If Matches.Count > 0 Then
            Set Match = Matches(0)
            If dname <> cname Then
                fileList.Add dname & "\" & Match.Value
            Else
                fileList.Add Match.Value
            End If
        End If
    Next
End Sub

' -- R}hC̎sBG[R[h, Wo, WG[o͂ԂB
Function ExecCmd(cmdLine)
    Dim shellObj, execObj, errorFlag
    Dim RC, StdOut, StdErr, outStr, errStr
    Set shellObj = WScript.CreateObject("WScript.Shell")
    errorFlag = False
    On Error Resume Next
    Set execObj = shellObj.Exec(cmdLine)
    If Err.Number <> 0 Then
        errorFlag = True
    End If
    Err.Clear
    On Error Goto 0
    If errorFlag = False Then
        Do While execObj.Status = 0
            WScript.Sleep 100
        Loop
        RC = execObj.ExitCode
        Set StdOut = execObj.StdOut
        Set StdErr = execObj.StdErr
        outStr = ""
        Do While Not StdOut.AtEndOfStream
            outStr = outStr & StdOut.ReadLine() & vbNewLine
        Loop
        errStr = ""
        Do While Not StdErr.AtEndOfStream
            errStr = errStr & StdErr.ReadLine() & vbNewLine
        Loop
        ExecCmd = Array(RC, outStr, errStr)
    Else  ' G[̏ꍇ
        ExecCmd = Array(255, "", "")
    End If
End Function

' ---- vZX̊ϐ Path ύX
Sub SetProcessEnv()
    Dim shellObj, fso, env, addPath, orgPath
    Dim si, str, alen
    Set shellObj = CreateObject("WScript.Shell")
    Set fso = CreateObject("Scripting.FileSystemObject")
    addPath = fso.getParentFolderName(WScript.ScriptFullName)
    Set env = shellObj.Environment("Process")
    orgPath = CStr(env.Item("PATH"))
    alen = Len(addPath)
    si = InStr(orgPath, addPath)
    If si > 0 Then
        str = Mid(orgPath, si, alen+1)
        If alen = Len(str) Then Exit Sub
        If Right(str, 1) = ";" Then Exit Sub
    End If
    env.Item("PATH") = addPath & ";" & orgPath
End Sub

' -- pandoc̃IvV
Sub InitializeOptions(optKeys, optDict)
    optDict("pandoc") = ""  ' pandocp̃IvV
End Sub

' -- pandocp̃IvVt@Cǂݎ
Sub GetOptions(ByVal filename, optKeys, optDict)
    Dim regex, regex2, Match, Matches, Matches2
    Dim fso, fileObj, line, key, val
        ' IvV̏
    InitializeOptions optKeys, optDict
        ' K\̐ݒ
    Set regex = New RegExp
    regex.Global = True
    regex.Pattern = "^<!--+"
    Set regex2 = New RegExp
    regex2.Global = True
        ' t@CIvVǂݎ
    Set fso = WScript.CreateObject("Scripting.FileSystemObject")
    If (fso.FileExists(filename) = False) Then
        Exit Sub
    End If
    Set fileObj = fso.OpenTextFile(filename)
    Do Until fileObj.AtEndOfStream = true
        line = fileObj.ReadLine
        Set Matches = regex.Execute(line)
        If Matches.Count > 0 Then
            regex2.IgnoreCase = False
            regex2.Pattern = "pandoc +(.+) +-->"
            Set Matches = regex2.Execute(line)
            If Matches.Count > 0 Then
                Set Matches2 = Matches(0).SubMatches
                val = optDict("pandoc")
                If val <> "" Then val = val & " "
                optDict("pandoc") = val & Matches2(0)
            End If
        End If
    Loop
    fileObj.Close
End Sub

' -- AddHeadingID.vbsĂяoāAoIDt
Function AddHeadingID(ByVal sjsPath, ByVal scriptDir)
    Dim fso, shellObj, scrPath, aidPath, cmdLine, resultArray
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    scrPath = scriptDir & "\AddHeadingID.vbs"
    scrPath = Replace(scrPath, "\\", "\")
    If (fso.FileExists(scrPath) = False) Then
        AddHeadingID = sjsPath
        Exit Function
    End If
    aidPath = ConveredFileName(sjsPath)
    cmdLine = scrPath & " " & sjsPath
    shellObj.Run cmdLine, 0, True
    If (fso.FileExists(aidPath) = False) Then
        AddHeadingID = sjsPath
    Else
        AddHeadingID = aidPath
    End If
End Function

' -- IDt̕ԊҌ̃t@C
Function ConveredFileName(ByVal Fname)
    Dim fso, extName, newName
    Set fso = CreateObject("Scripting.FileSystemObject")
    extName = fso.GetExtensionName(Fname)
    newName = Fname
    If extName <> "" Then
        extName = "." & extName
        newName = Mid(Fname, 1, InStr(Fname, extName) - 1) & "+ID" & extName
    Else
        newName = Fname & "+ID"
    End If
    ConveredFileName = newName
    Set fso = Nothing
End Function

' -- 郁j[ւ̓o^܂͏
Sub setSendTo()
    Dim fso, shellObj, scriptDir, sendtoDir
    Dim targetFile, targetName, lnkFile, shortcut
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    targetFile = Wscript.ScriptFullName
    targetName = fso.GetBaseName(targetFile)
    sendtoDir = shellObj.SpecialFolders("SendTo")
    lnkFile = sendtoDir & "\" & targetName & ".lnk"
    If (fso.FileExists(lnkFile) = True) Then
        fso.DeleteFile(lnkFile)
        MsgBox "郁j[ " & targetName & "܂.", _
            0, ""
        Exit Sub
    End If
    Set shortcut = shellObj.CreateShortCut(lnkFile)
    shortcut.TargetPath = targetFile
    shortcut.save
    MsgBox "郁j[ " & targetName & "o^܂.", 0, "o^"
End Sub
