' usePandoc.vbs: markdown file  docx, HTML, PPTX by pandoc
'      2019/03/13
'      2019/11/26 (WildCard̃oOC, ppt̎㏈ǉ)
'      2020/02/24 (docxւ̕ϊɂĉET_ɑΉ)
'    Copyright (C) T. Yoshiizumi, 2019 All rights reserved.
Option Explicit
Main WScript.Arguments
WScript.Quit

' -- v
Sub Main(argsObj)
    Dim wdApp, pptApp, inputFile, sjsFile, logFile, fileList, procCount, extStr
    Dim optKeys, opt, optDict, sizeDict
    Dim fso, sjsPathOrg, sjsPath, utfPath, scriptDir
    Dim extName, extType, outFile, cmdLine, resultArray
    Dim shellObj, RC, pandocExe, soundVolume, normalSound, errorSound
        ' eϐ̐ݒ
    soundVolume = 100
    normalSound = "C:\Windows\Media\tada.wav"  ' ÎƂ̉
    errorSound = "C:\Windows\Media\ringout.wav"  ' G[ÎƂ̉
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    scriptDir = fso.GetParentFolderName(Wscript.ScriptFullName)
    pandocExe = "pandoc.exe"
    Set fileList = CreateObject("System.Collections.ArrayList")  ' ϒz
    Set wdApp = Nothing
    Set pptApp = Nothing
        ' IvVƗpTCYɊւzƎݒ
    Set sizeDict = WScript.CreateObject("Scripting.Dictionary")
    sizeDict.Add "B4", 257364
    sizeDict.Add "A4", 210297
    sizeDict.Add "B5", 182257
    sizeDict.Add "A5", 148210
    sizeDict.Add "HG", 100148
    optKeys = Array("TableBorder", "TableCenter", "TableRow1", _
        "FontSize", "PageSize", "PageNumber", _
        "TextColumns", "CharsLine", "LinesPage", _
        "ImageCenter", "portrait", "pandoc", "RemakeAfter")
    Set optDict = WScript.CreateObject("Scripting.Dictionary")
    InitializeOptions optKeys, optDict
        ' Ώۃt@C̔c
    If argsObj.Count < 2 Then
        If argsObj.Count < 1 Then
            inputFile = InputBox("t@CH", "t@C̓")
        Else
            inputFile = argsObj(0)
        End If
        If inputFile = "" Then
            Exit Sub
        End If
        If inputFile = "/" Or LCase(inputFile) = "sendto" Then
            setSendTo
            Exit Sub
        End If
        GetWildCard inputFile, fileList
    Else  ' argsObj.Count >= 2
        For Each inputFile In argsObj
            GetWildCard inputFile, fileList
        Next
    End If
    extType = SelectExt()
    extName = "." & LCase(extType)  ' 쐬t@C̊gq
    If fileList.Count = 0 Then
        shellObj.CurrentDirectory = scriptDir
    Else
        shellObj.CurrentDirectory = fso.GetParentFolderName( _
            FullPath(fileList(0)))
    End If
    logFile = "log.txt"  ' Oot@C
    If (fso.FileExists(logFile) = True) Then fso.DeleteFile(logFile)
    MessageWrite logFile, "make " & extType & " :"
    procCount = 0
    If fileList.Count = 0 Then
        MessageWrite logFile, "'" & inputFile & _
            "' ܂." & vbNewLine
    End If
    SetProcessEnv
    For Each sjsFile In fileList
        extStr = LCase(fso.GetExtensionName(sjsFile))
        If extStr <> "" And InStr("txt md", extStr) > 0 And _
            FullPath(sjsFile) <> FullPath(logFile) Then
            MessageWrite logFile, "* t@C: " & fso.GetFileName(sjsFile)
            sjsPathOrg = FullPath(sjsFile)
            sjsPath = sjsPathOrg
            If extName = ".html" Then
                sjsPath = AddHeadingID(sjsPath, scriptDir)
            End If
            utfPath = CutExtName(sjsPathOrg) & ".$utf"
            If (fso.FileExists(utfPath) = True) Then fso.DeleteFile(utfPath)
            SjsToUtf sjsPath, utfPath  ' ShiftJIS  utf-8
            outFile = CutExtName(utfPath) & extName
            If (fso.FileExists(outFile) = True) Then fso.DeleteFile(outFile)
            GetOptions sjsPath, optKeys, optDict
            cmdLine = pandocExe & " """ & utfPath & """ -s -f markdown " & _
                "--data-dir=""" & scriptDir & "\pandoc"" " & _
                "-o """ & outFile & """ " & optDict("pandoc")
            resultArray = ExecCmd(cmdLine)
            fso.DeleteFile(utfPath)
            If sjsPath <> sjsPathOrg Then
                fso.DeleteFile(sjsPath)
                MessageWrite logFile, "* IDt܂."
            End If
            RC = resultArray(0)
            If RC <> 0 Then
                MessageWrite logFile, "* pandoc̎sɎs܂." & _
                    vbNewLine & "* CommandLine: " & cmdLine
            Else
                MessageWrite logFile, "* pandoc̎sɐ."
                procCount = procCount + 1
            End If
            If resultArray(1) <> "" Then
                MessageWrite logFile, "* StdOut: " & resultArray(1)
            End If
            If resultArray(2) <> "" Then
                MessageWrite logFile, "* StdErr: " & resultArray(2)
            End If
            If LCase(extName) = ".docx" Then
                remakeDOCX wdApp, outFile, optDict, sizeDict, logFile
            ElseIf LCase(extName) = ".pptx" Then
                remakePPTX pptApp, outFile, optDict, logFile
            End If
            MessageWrite logFile, ""
        ElseIf FullPath(sjsFile) <> FullPath(logFile) Then
            MessageWrite logFile, "* ΏۊO: " & fso.GetFileName(sjsFile)
        End If
    Next

    If TypeName(wdApp) <> "Nothing" Then
        wdApp.Quit
    End If
    If TypeName(pptApp) <> "Nothing" Then
        pptApp.Quit
    End If
    If (procCount = 0) Then
        SoundPlay errorSound, soundVolume
    Else
        SoundPlay normalSound, soundVolume
    End If
End Sub

' -- t@C̃tpX𓾂
Function FullPath(ByVal Fname)  ' t@C̐΃pX̎擾
    Dim fso
    Set fso = CreateObject("Scripting.FileSystemObject")
   FullPath = fso.GetAbsolutePathName(Fname)
    Set fso = Nothing
End Function

' -- gqpX擾
Function CutExtName(ByVal Fname)
    Dim fso, ExtName
    Set fso = CreateObject("Scripting.FileSystemObject")
    ExtName = fso.GetExtensionName(Fname)
    If ExtName <> "" Then
        Fname = Mid(Fname, 1, InStr(Fname, "." & ExtName) - 1)
    End If
    CutExtName = Fname
    Set fso = Nothing
End Function

' -- Shift_JIS file  utf-8 file
Sub SjsToUtf(ByVal sjsPath, ByVal utfPath)
    Dim objSJIS, objUTF8
    Set objSJIS = CreateObject("ADODB.Stream")
    Set objUTF8 = CreateObject("ADODB.Stream")
    objSJIS.Type = 2
    objSJIS.Charset = "Shift_JIS"
    objSJIS.Open
    objSJIS.LoadFromFile sjsPath
    objUTF8.Type = 2
    objUTF8.Charset = "UTF-8"
    objUTF8.Open
    objSJIS.CopyTo objUTF8
    objUTF8.SaveTofile utfPath
    objSJIS.Close
    objUTF8.Close
End Sub

' -- t@Cւ̏o
Sub MessageWrite(ByVal logFile, ByVal msgStr)
    Dim fso, msgOut
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set msgOut = fso.OpenTextFile(logFile, 8, True)  ' ǉ
    msgOut.WriteLine msgStr
    msgOut.Close
End Sub

' -- K\̏ƍB}b`ԂB
Function regexMatch(ByVal patrn, ByVal strng)
    Dim regEx, Match, Matches, RetStr
    Set regEx = New RegExp
    regEx.Pattern = patrn
    regEx.Global = True
    Set Matches = regEx.Execute(strng)
    If Matches.Count > 0 Then
        Set Match = Matches(0)
        RetStr = Match.Value
    Else  ' }b`ȂƂ͌̕񂻂̂܂܂Ԃ
        RetStr = strng
    End If
    regexMatch = RetStr
End Function

' -- t@C̍Đ
Sub SoundPlay(wavFile, soundVolume)
    Dim fso, wmp
Set fso = CreateObject("Scripting.FileSystemObject")
    If (fso.FileExists(wavFile) = False) Then
        Exit Sub
    End If
    Set wmp = CreateObject("WMPlayer.OCX")
    wmp.settings.volume = soundVolume ' ʐݒ
    wmp.URL = wavFile
    wmp.Controls.play()  ' Đ
    Do  ' Đҋ@
        WScript.sleep(5)
    Loop Until wmp.playState = 1  ' ~҂
End Sub

' -- ChJ[h̓Iȃt@C̃Xgɂ
Sub GetWildCard(ByVal wildName, fileList)
    Dim fso, fname, dname, cname, ptn, f, ch
    Dim regEx, Match, Matches, RetStr
        ' t@CAtH_Ȃǂ𓾂
    Set fso = CreateObject("Scripting.FileSystemObject")
    wildName = fso.GetAbsolutePathName(wildName)
    If InStr(wildName, "*") = 0 And InStr(wildName, "?") = 0 Then
        fileList.Add wildName
        Exit Sub
    End If
    fname = fso.GetFileName(wildName)
    dname = fso.GetParentFolderName(wildName)
    If fso.FolderExists(dname) = False Then
        Exit Sub
    End If
    cname = fso.GetFolder(".")
    If Right(fname, 3) = "*.*" Then
        ptn = Left(fname, Len(fname)-2)
    ElseIf Right(fname, 2) = ".*" Then
        ptn = Left(fname, Len(fname)-2) & "*"
    Else
        ptn = fname
    End If
    ptn = Replace(ptn, "\", Chr(7) & Chr(7))
    For Each ch In Split(".,(,),[,],{,},^,$,+,|", ",")
        ptn = Replace(ptn, ch, Chr(7) & ch)
    Next
    ptn = Replace(ptn, "*", ".*")
    ptn = Replace(ptn, "?", ".?")
    ptn = Replace(ptn, Chr(7), "\")
    ptn = "^" & ptn & "$"
    Set regEx = New RegExp
    regEx.Pattern = ptn
    regEx.Global = True
    regEx.IgnoreCase = True
        ' tH_̃t@CƃChJ[hEp^[Ƃ̏ƍo
    For Each f In fso.GetFolder(dname).Files
        Set Matches = regEx.Execute(f.Name)
        If Matches.Count > 0 Then
            Set Match = Matches(0)
            If dname <> cname Then
                fileList.Add dname & "\" & Match.Value
            Else
                fileList.Add Match.Value
            End If
        End If
    Next
End Sub

' -- R}hC̎sBG[R[h, Wo, WG[o͂ԂB
Function ExecCmd(cmdLine)
    Dim shellObj, execObj, errorFlag
    Dim RC, StdOut, StdErr, outStr, errStr
    Set shellObj = WScript.CreateObject("WScript.Shell")
    errorFlag = False
    On Error Resume Next
    Set execObj = shellObj.Exec(cmdLine)
    If Err.Number <> 0 Then
        errorFlag = True
    End If
    Err.Clear
    On Error Goto 0
    If errorFlag = False Then
        Do While execObj.Status = 0
            WScript.Sleep 100
        Loop
        RC = execObj.ExitCode
        Set StdOut = execObj.StdOut
        Set StdErr = execObj.StdErr
        outStr = ""
        Do While Not StdOut.AtEndOfStream
            outStr = outStr & StdOut.ReadLine() & vbNewLine
        Loop
        errStr = ""
        Do While Not StdErr.AtEndOfStream
            errStr = errStr & StdErr.ReadLine() & vbNewLine
        Loop
        ExecCmd = Array(RC, outStr, errStr)
    Else  ' G[̏ꍇ
        ExecCmd = Array(255, "", "")
    End If
End Function

' ---- vZX̊ϐ Path ύX
Sub SetProcessEnv()
    Dim shellObj, fso, env, addPath, orgPath
    Dim si, str, alen
    Set shellObj = CreateObject("WScript.Shell")
    Set fso = CreateObject("Scripting.FileSystemObject")
    addPath = fso.getParentFolderName(WScript.ScriptFullName)
    Set env = shellObj.Environment("Process")
    orgPath = CStr(env.Item("PATH"))
    alen = Len(addPath)
    si = InStr(orgPath, addPath)
    If si > 0 Then
        str = Mid(orgPath, si, alen+1)
        If alen = Len(str) Then Exit Sub
        If Right(str, 1) = ";" Then Exit Sub
    End If
    env.Item("PATH") = addPath & ";" & orgPath
End Sub

' -- WordCpandoc̃IvV
Sub InitializeOptions(optKeys, optDict)
    Dim key
    For Each key In optKeys
        If optDict.Exists(key) = False Then
            optDict.Add key, True
        Else
            optDict(key) = True
        End If
    Next
    optDict("FontSize") = 12.0
    optDict("TextColumns") = 1
    optDict("CharsLine") = 0
    optDict("LinesPage") = 0
    optDict("PageSize") = "A4"
    optDict("pandoc") = ""  ' pandocp̃IvV
End Sub

' -- WordCpandocp̃IvVt@Cǂݎ
Sub GetOptions(ByVal filename, optKeys, optDict)
    Dim regex, regex2, Match, Matches, Matches2
    Dim fso, fileObj, line, key, val
        ' IvV̏
    InitializeOptions optKeys, optDict
        ' K\̐ݒ
    Set regex = New RegExp
    regex.Global = True
    regex.Pattern = "^<!--"
    Set regex2 = New RegExp
    regex2.Global = True
        ' t@CIvVǂݎ
    Set fso = WScript.CreateObject("Scripting.FileSystemObject")
    If (fso.FileExists(filename) = False) Then
        Exit Sub
    End If
    Set fileObj = fso.OpenTextFile(filename)
    Do Until fileObj.AtEndOfStream = true
        line = fileObj.ReadLine
        Set Matches = regex.Execute(line)
        If Matches.Count > 0 Then
            For Each key In optKeys
                If key = "FontSize" Then
                    val = "([0-9.]+)"
                ElseIf key = "TextColumns" Then
                    val = "([1-9])"
                ElseIf key = "CharsLine" Or key = "LinesPage" Then
                    val = "([0-9]+)"
                Else
                    val = "(yes|no)"
                End If
                regex2.Pattern = "(" & key & ")=" & val
                Set Matches = regex2.Execute(line)
                If Matches.Count > 0 Then
                    Set Matches2 = Matches(0).SubMatches
                    If Matches2(0) = "FontSize" Then
                        val = CSng(Matches2(1))
                        optDict(Matches2(0)) = val
                    ElseIf InStr("TextColumns CharsLine LinesPage", _
                        Matches2(0)) <> 0 Then
                        val = CInt(Matches2(1))
                        optDict(Matches2(0)) = val
                    ElseIf InStr("PageSize pandoc", Matches2(0)) = 0 Then
                        If Matches2(1) = "no" Then val = False Else val = True
                        optDict(Matches2(0)) = val
                    End If
                End If
            Next
            regex2.Pattern = "PageSize=(B4|A4|B5|A5|HG)(L|l)?"
            regex2.IgnoreCase = True
            Set Matches = regex2.Execute(line)
            If Matches.Count > 0 Then
                Set Matches2 = Matches(0).SubMatches
                optDict("PageSize") = UCase(Matches2(0))
                If UCase(Matches2(1)) = "L" Then val = False Else val = True
                optDict("portrait") = val
            End If
            regex2.IgnoreCase = False
            regex2.Pattern = "pandoc +(.+) +-->"
            Set Matches = regex2.Execute(line)
            If Matches.Count > 0 Then
                Set Matches2 = Matches(0).SubMatches
                val = optDict("pandoc")
                If val <> "" Then val = val & " "
                optDict("pandoc") = val & Matches2(0)
            End If
        End If
    Loop
    fileObj.Close
End Sub

' ---- gq̑I
Function SelectExt()
    Dim shellObj, selectArray, selectCount, intMsg
    selectArray = Array("DOCX", "HTML", "PPTX")
    selectCount = 0
    Set shellObj = Wscript.CreateObject("Wscript.Shell")
    Do
        intMsg = shellObj.Popup (selectArray(selectCount), _
            7, "I", vbYesNo)
        If intMsg = -1 Or intMsg = vbYes Then Exit Do
        selectCount = (selectCount + 1) Mod 3
    Loop
    SelectExt = selectArray(selectCount)
End Function

' -- AddHeadingID.vbsĂяoāAoIDt
Function AddHeadingID(ByVal sjsPath, ByVal scriptDir)
    Dim fso, shellObj, scrPath, aidPath, cmdLine, resultArray
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    scrPath = scriptDir & "\AddHeadingID.vbs"
    scrPath = Replace(scrPath, "\\", "\")
    If (fso.FileExists(scrPath) = False) Then
        AddHeadingID = sjsPath
        Exit Function
    End If
    aidPath = ConveredFileName(sjsPath)
    cmdLine = scrPath & " " & sjsPath
    shellObj.Run cmdLine, 0, True
    If (fso.FileExists(aidPath) = False) Then
        AddHeadingID = sjsPath
    Else
        AddHeadingID = aidPath
    End If
End Function

' -- IDt̕ԊҌ̃t@C
Function ConveredFileName(ByVal Fname)
    Dim fso, extName, newName
    Set fso = CreateObject("Scripting.FileSystemObject")
    extName = fso.GetExtensionName(Fname)
    newName = Fname
    If extName <> "" Then
        extName = "." & extName
        newName = Mid(Fname, 1, InStr(Fname, extName) - 1) & "+ID" & extName
    Else
        newName = Fname & "+ID"
    End If
    ConveredFileName = newName
    Set fso = Nothing
End Function

' -- 郁j[ւ̓o^܂͏
Sub setSendTo()
    Dim fso, shellObj, scriptDir, sendtoDir
    Dim targetFile, targetName, lnkFile, shortcut
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set shellObj = WScript.CreateObject("WScript.Shell")
    targetFile = Wscript.ScriptFullName
    targetName = fso.GetBaseName(targetFile)
    sendtoDir = shellObj.SpecialFolders("SendTo")
    lnkFile = sendtoDir & "\" & targetName & ".lnk"
    If (fso.FileExists(lnkFile) = True) Then
        fso.DeleteFile(lnkFile)
        MsgBox "郁j[ " & targetName & "܂.", _
            0, ""
        Exit Sub
    End If
    Set shortcut = shellObj.CreateShortCut(lnkFile)
    shortcut.TargetPath = targetFile
    shortcut.save
    MsgBox "郁j[ " & targetName & "o^܂.", 0, "o^"
End Sub

' wӏɉ܂͖T_
Function AddUnderLineEtc(docObj)
    Dim rng, flag, ln, pos, ch, num, val, v
    Dim infoText, infoMsg, infoLose, num_alph
    num_alph = "0123456789abcdefghijklmnopqrstuvwxyz"
    infoMsg = ""
    infoLose = ""
    Set rng = docObj.Content
    Do
        rng.Find.MatchFuzzy = False
        rng.Find.MatchWildcards = True
        flag = rng.Find.Execute("#[!{]@\{[!}]@\}")
        If flag = False Then Exit Do
        infoText = rng.Text
        pos = InStr(rng.Text, "{")
        ch = LCase(Mid(rng.Text, 2, 1))
        num = LCase(Mid(rng.Text, 3, 1))
        If (pos = 3 Or pos = 4) And (ch = "u" Or ch = "e") Then
            ln = Len(rng.Text)
            val = 1
            If pos = 4 Then
                v = InStr(num_alph, num)
                If v > 0 Then val = v - 1
            End If
            rng.Text = Mid(rng.Text, pos+1, ln-pos-1)
            Select Case ch
            Case "u"
                rng.Font.Underline = val
            Case "e"
                rng.Font.EmphasisMark = val
            End Select
            infoMsg = infoMsg & vbTab & infoText & _
                vbTab & "ϊɐ" & vbNewLine
        Else
            infoLose = infoLose & vbTab & "! " & infoText & _
                vbTab & "ϊɎs" & vbNewLine
        End If
        rng.SetRange rng.End, docObj.Content.End
    Loop
    AddUnderLineEtc = infoLose & infoMsg
End Function

' -- Wordɂdocxt@C̍ĕҏW
Sub remakeDOCX(wdApp, ByVal filename, optDict, sizeDict, ByVal logFile)
    Dim fso, docPath, errorFlag
    Dim docObj, tblObj, cellObj, shpObj
    Dim tpl, lvl, nf, nf2, ns, rng, i
    Dim width, height, v, tc, lastPos, lastChar, infoStr, sz, infoMsg
    If (optDict("RemakeAfter") = False) Then
        Exit Sub
    End If
        ' [h̋Nƃt@CI[v
    Set fso = CreateObject("Scripting.FileSystemObject")
    docPath = fso.GetAbsolutePathName(filename)
    If (fso.FileExists(docPath) = False) Then
        Exit Sub
    End If
    If TypeName(wdApp) = "Nothing" Then
        errorFlag = False
        On Error Resume Next
        Set wdApp = CreateObject("Word.Application")  ' Word̋N
        If Err.Number <> 0 Then
            errorFlag = True
        End If
        Err.Clear
        On Error Goto 0
        If errorFlag = True Then
            Set wdApp = Nothing
            Exit Sub
        End If
        wdApp.Visible = True  ' WordԂ
    End If
    Set docObj = wdApp.Documents.Open(docPath)
    infoMsg = AddUnderLineEtc(docObj)
    infoStr = ""
    With docObj
        If optDict("FontSize") <> 12.0 Then  ' tHgTCY
            .Styles(-1).Font.Size = optDict("FontSize")
        End If
        If sizeDict.Exists(optDict("PageSize")) Then
            width = sizeDict(optDict("PageSize")) \ 1000
            height = sizeDict(optDict("PageSize")) Mod 1000
            If optDict("portrait") = False Then  ' cƉt]
                v = width
                width = height
                height = v
            End If
            .PageSetup.PageWidth = wdApp.MillimetersToPoints(width)
            .PageSetup.PageHeight = wdApp.MillimetersToPoints(height)
            .PageSetup.FooterDistance = wdApp.MillimetersToPoints(17.5)
            .PageSetup.HeaderDistance = wdApp.MillimetersToPoints(15.0)
        End If
        If optDict("PageNumber") = True Then
            Set rng = .Sections(1).Footers(1).Range  ' tb^[̈
            rng.Text = "p/n"  ' ̕
            rng.Fields.Add rng.Words(1), -1, "PAGE", False
            rng.Fields.Add rng.Words(3), -1, "NUMPAGES", False
            rng.ParagraphFormat.Alignment = 1  ' 
        End If
        If optDict("TextColumns") <> 1 Then  ' ig
            .Sections(1).PageSetup.TextColumns.SetCount(optDict("TextColumns"))
            .Sections(1).PageSetup.TextColumns.EvenlySpaced = True 'iԊuϓ
            .Sections(1).PageSetup.TextColumns.LineBetween = True ' E
        End If
        If optDict("CharsLine") = 0 And optDict("LinesPage") = 0 Then
            .PageSetup.LayoutMode = 0  ' W̕g
        ElseIf optDict("CharsLine") > 0 Then
            .PageSetup.LayoutMode = 1  ' ƍsw
            .PageSetup.CharsLine = optDict("CharsLine")
            If optDict("LinesPage") > 0 Then  ' 1y[W̍s
                .PageSetup.LinesPage = optDict("LinesPage")
            End If
        ElseIf optDict("LinesPage") > 0 Then
            .PageSetup.LayoutMode = 2  ' sw
            .PageSetup.LinesPage = optDict("LinesPage")
        End If
            ' ӏ̐擪 i.  @
        For Each tpl In .ListTemplates
            For Each lvl In tpl.ListLevels
                nf = lvl.NumberFormat  ' sԍ̏
                nf2 = regexMatch("%[0-9]+", nf)
        ns =    lvl.NumberStyle  ' sԍ̎
                If ns = 2 Then  ' [}`
                    lvl.NumberStyle = 18
                    lvl.NumberFormat = nf2
                End If
            Next
        Next
            ' \̌rt違Psڂϓt
        For Each tblObj In .Tables
            If optDict("TableBorder") = True Then
                tblObj.Borders.InsideLineStyle = 1  ' wdLineStyleSingle
                tblObj.Borders.OutsideLineStyle = 7  ' wdLineStyleDouble
            End If
            If optDict("TableRow1") = True Then
                For Each cellObj In tblObj.Rows(1).Cells  ' 1sڂϓt
                    cellObj.Range.ParagraphFormat.Alignment = 4
                Next
            End If
            If optDict("TableCenter") = True Then
                tblObj.Rows.Alignment = 1  ' y[Wŕ\𒆉낦
                Set rng = tblObj.Cell(1, 1).Range
                rng.Start = 0
                i = rng.Paragraphs.Count
                If i > 1 Then
                    Set rng = .Paragraphs(i-1).Range  ' \̐HO̒i
                    If rng.Style.NameLocal = "Table Caption" Then
                        rng.ParagraphFormat.Alignment = 1  ' 
                    End If
                End If
            End If
        Next
        If optDict("ImageCenter") = True Then
            For Each shpObj In .InlineShapes
                Set rng = shpObj.Range
                If rng.Paragraphs(1).Range.Text = ("/" & vbCr) Then
                    rng.ParagraphFormat.Alignment = 1  ' }𒆉낦
                    rng.Start = 0
                    i = rng.Paragraphs.Count
                    If i < .Paragraphs.Count Then
                        Set rng = .Paragraphs(i+1).Range  ' }̒̒i
                        If rng.Style.NameLocal = "Image Caption" Then
                            rng.ParagraphFormat.Alignment = 1  ' 
                        End If
                    End If
                End If
            Next
        End If
        For Each tc In .TablesOfContents
            tc.UpdatePageNumbers  ' ڎ̃y[WԍXV
        Next
    End With
    docObj.SetCompatibilityMode(65535)
    docObj.Save
        ' y[WȂǂ̏擾
    lastPos = docObj.Range.End - 1
    Set lastChar = docObj.Range(lastPos, lastPos)
    infoStr = docObj.PageSetup.CharsLine & " ~ " & _
        docObj.PageSetup.LinesPage & "s ~ " & _
        lastChar.Information(3) & "y[W, " & _
        "ŏIy[W̍s " & lastChar.Information(10)
    docObj.Close
    If infoStr <> "" Then
        sz = Left(optDict("PageSize"), 2)
        If InStr("B4 A4 B5 A5 HG", sz) = 0 Then
            sz = "letter"
        End If
        If sz = "HG" Then sz = "nKL"
        If optDict("portrait") = False Then sz = sz & " "
        infoStr = sz & ": " & infoStr
        MessageWrite logFile, "* " & infoStr
    End If
    If infoMsg <> "" Then
        MessageWrite logFile, "* ET_̏:" & vbNewLine & infoMsg
    End If
End Sub

' -- PowerPointɂpptxt@C̍ĕҏW
Sub remakePPTX(pptApp, ByVal filename, optDict, ByVal logFile)
    Dim fso, pptPath, errorFlag
    Dim presenObj, slideObj, shapeObj, tbl, cel, asStr
    If (optDict("RemakeAfter") = False) Then
        Exit Sub
    End If
        ' PowerPoint̋Nƃt@CI[v
    Set fso = CreateObject("Scripting.FileSystemObject")
    pptPath = fso.GetAbsolutePathName(filename)
    If (fso.FileExists(pptPath) = False) Then
        Exit Sub
    End If
    If TypeName(pptApp) = "Nothing" Then
        errorFlag = False
        On Error Resume Next
        Set pptApp = CreateObject("PowerPoint.Application")
        If Err.Number <> 0 Then
            errorFlag = True
        End If
        Err.Clear
        On Error Goto 0
        If errorFlag = True Then
            Set pptApp = Nothing
            Exit Sub
        End If
        pptApp.Visible = True
    End If
    Set presenObj = pptApp.Presentations.Open(pptPath)
        ' \̌rt違Psڂϓt
    For Each slideObj In presenObj.Slides
        For Each shapeObj In slideObj.Shapes
            If (shapeObj.HasTable <> 0) Then
                Set tbl = shapeObj.Table
                If optDict("TableBorder") = True Then
                    asStr = _
                        "{5940675A-B579-460E-94D1-54222C63F5DA}"
                Else
                    asStr = _
                        "{2D5ABB26-0587-4C30-8999-92F81FD0307C}"
                End If
                tbl.ApplyStyle asStr
                If optDict("TableRow1") = True Then
                    For Each cel In tbl.Rows(1).Cells
                        cel.Shape.TextFrame.TextRange _
                                .ParagraphFormat.Alignment = 5
                    Next
                End If
            End If
        Next
    Next
    presenObj.Save
    presenObj.Close
End Sub
